module main
import io
import net
import os

fn main() {
	mut port := ":1234"

	if os.args.len == 1 {
		println("Using default port number")
	} else {
		port = ':' + os.args[1]
	}

	mut server := net.listen_tcp(.ip, port) ?
	laddr := server.addr() ?
	println('Echo server listening at $laddr')

	for {
		mut socket := server.accept() ?
		go handle_connection(mut socket)
	}
}

fn handle_connection(mut socket net.TcpConn) {
	defer {
		socket.close() or {
			panic(err)
		}
	}

	client_addr := socket.peer_addr() or { 
		return 
	}
	println('> new client: $client_addr')
	mut reader := io.new_buffered_reader(reader: socket)
	defer {
		reader.free()
	}

	socket.write_string('This is your echo server speaking!\n') or {
		return
	}
	for {
		client_data := reader.read_line() or {
			return
		}
		if client_data == '' {
			return
		}
		println('C $client_addr: $client_data')
		// Send back the original message
		socket.write_string('server: $client_data\n') or {
			return
		}
	}
}
